#ifndef _ForlanoOption_ForlanoOption_h
#define _ForlanoOption_ForlanoOption_h

#include <CtrlLib/CtrlLib.h>

#define IMAGEFILE <ForlanoOption/ForlanoOption.iml>
#include <Draw/iml_header.h>


class OptionImage : public Option {
protected:
	Image imgYes, imgNo, imgMaybe;
public:
	virtual void   Paint(Draw& draw);
	OptionImage& SetImage(const Image& m1, const Image& m2, const Image& m3)
			            { imgYes = m1; imgNo = m2; imgMaybe = m3; Refresh(); return *this; }
	OptionImage& SetImage(const Image& m1, const Image& m2)
			            { imgYes = m1; imgNo = m2; Refresh(); return *this; }
			            
	OptionImage& ThreeState(bool b = true)             { threestate = b; notnull = false; return *this; }

	typedef OptionImage CLASSNAME;
	OptionImage();
	~OptionImage(){;}
};

OptionImage::OptionImage()
{

}


void OptionImage::Paint(Draw& w) {
	Size sz = GetSize();
	if(!IsTransparent())
		w.DrawRect(0, 0, sz.cx, sz.cy, SColorFace);
	Size isz = imgYes.GetSize();  //although maybe it would be good to calc from the biggest...?
	Size tsz = GetSmartTextSize(w, label, font);
	int ty = (sz.cy - tsz.cy) / 2; //text up-down
	int iy = (tsz.cy - isz.cy) / 2 + ty;
	bool ds = !IsShowEnabled();

		Image m = (!notnull || threestate) && IsNull(option) ? ds ? imgMaybe
				                      : IsPush() ? imgYes
							                     : imgMaybe :
			      option == 1 ? ds ? (switchimage ? imgYes : imgYes)
				                   : IsPush() ? (switchimage ? imgYes : imgYes)
							                  : (switchimage ? imgYes : imgYes)
				              : ds ? (switchimage ? imgNo : imgNo)
				                   : IsPush() ? (switchimage ? imgNo : imgNo)
							                  : (switchimage ? imgNo : imgNo);
		w.DrawImage(0, iy, m);
	//	if(!switchimage) //for borders - need to adjust sizes...
	//		w.DrawImage(0, iy, ds ? CtrlImg::optionedged : blackedge ? CtrlImg::blackoptionedge : CtrlImg::optionedge);

	DrawSmartText(w, isz.cx + 4, ty, tsz.cx, label, font, ds ? SGray : SBlack, VisibleAccessKeys() ? accesskey : 0);
	//text length problem - tsz.cx - doesn't work?
}


#define LAYOUTFILE <ForlanoOption/ForlanoOption.lay>
#include <CtrlCore/lay.h>




class ForlanoOption : public WithForlanoOptionLayout<TopWindow> {
public:
	typedef ForlanoOption CLASSNAME;
	ForlanoOption();
};

#endif

